
 /* SuperPlay.h
    - Include File for global functions and variables -
    (c) 1994 by Andreas R. Kleinert
    Last changes : 21.07.1994
 */

#ifndef SUPERPLAY_H
#define SUPERPLAY_H


#ifndef INTUITION_INTUITION_H
#include <intuition/intuitionbase.h>
#endif /* INTUITION_INTUITION_H */

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif /* EXEC_MEMORY_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef GRAPHICS_GFXBASE_H
#include <graphics/gfxbase.h>
#endif /* GRAPHICS_GFXBASE_H */

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>
#endif /* LIBRARIES_DOS_H */

#ifndef LIBRARIES_ASL_H
#include <libraries/asl.h>
#endif /* LIBRARIES_ASL_H */

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif /* UTILITY_TAGITEM_H */

#ifndef _STDIO_H
#include <stdio.h>
#endif /* _STDIO_H */

#ifndef _STDLIB_H
#include <stdlib.h>
#endif /* _STDLIB_H */

#ifndef _STRING_H
#include <string.h>
#endif /* _STRING_H */

#ifndef _CTYPE_H
#include <ctype.h>
#endif /* _CTYPE_H */

#include <superplay/superplaybase.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/gadtools.h>
#include <proto/asl.h>

#include <proto/superplay.h>
#include <proto/spobjects.h>

#include "SuperPlay_Main.h"
#include "SP_SPOListSubs.h"


/* *************************************************** */
/* *						     * */
/* * Version Defines				     * */
/* *						     * */
/* *************************************************** */

#define SP_STRDEF_VER	  "\0$VER: "
#define SP_STRDEF_VERSION "SuperPlay V3.1"
#define SP_STRDEF_DATE	  "(21.7.94)"


/* *************************************************** */
/* *						     * */
/* * MACROs for Version-Tests			     * */
/* *						     * */
/* *************************************************** */

#define LibVer(x) ( ((struct Library *) x)->lib_Version )
#define OS_VER	  LibVer(SysBase)


/* *************************************************** */
/* *						     * */
/* * SuperPlay.c : Functions			     * */
/* *						     * */
/* *************************************************** */

extern void __regargs Leave(char *errtext, APTR mlist, long code);


/* *************************************************** */
/* *						     * */
/* * Additional Base References  		     * */
/* *						     * */
/* *************************************************** */

extern struct ExecBase	    *SysBase;
extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase	    *GfxBase;
extern struct Library	    *GadToolsBase;
extern struct SuperPlayBase *SuperPlayBase;


/* *************************************************** */
/* *						     * */
/* * Globally Referenced Variables		     * */
/* *						     * */
/* *************************************************** */

extern struct SPS_SPOList     *SPOList;


/* *************************************************** */
/* *						     * */
/* * Compiler Stuff for BackgroundIO		     * */
/* *						     * */
/* *************************************************** */

extern BPTR _Backstdout; /* NULL, if started from Workbench */


/* *************************************************** */
/* *						     * */
/* * References for GUI Access                       * */
/* *						     * */
/* *************************************************** */

extern struct Screen *Scr;
extern struct Window *SP_Main_Wnd;


/* *************************************************** */
/* *						     * */
/* * Specific Definitions                            * */
/* *						     * */
/* *************************************************** */

struct SP_RememberPath
{
 char rp_Dir  [256]; /* dir                   */
 char rp_File [256]; /* file                  */
 char rp_Path [256]; /* dir + ("/"| %) + file */
};


#endif /* SUPERPLAY_H */
